Subject: [ippm] New Draft: draft-mizrahi-owamp-twamp-checksum-trailer-00

From: Tal Mizrahi <[email-masked]>
Date: Tue, 28 May 2013 19:26:13 +0300

Hi,

History:

-          http://tools.ietf.org/html/draft-mizrahi-tictoc-checksum-trailer-00
Originally submitted to TICTOC in 2011, and discussed checksum trailers for both NTP and OWAMP/TWAMP.

-          There was some discussion in the mailing list: http://www.ietf.org/mail-archive/web/ntp/current/msg00492.html

-          Some discussion in IETF 81: http://tools.ietf.org/wg/tictoc/minutes?item=minutes81.html

Current version:

-          Split into 2 drafts. There are some similarities, but still it is more appropriate to discuss it as two separate drafts:

http://tools.ietf.org/html/draft-mizrahi-ntp-checksum-trailer-00
http://tools.ietf.org/html/draft-mizrahi-owamp-twamp-checksum-trailer-00

-          [NTP draft] Clarified the usage of the NTP extension field without authentication.

Comments will be appreciated.

Thanks,
Tal.

---

From: Steve Baillargeon <[email-masked]>
Date: Tue, 28 May 2013 20:02:01 +0000

Hi Tal
Good work!

For OWAM/TWAMP, since you are changing the test packet format, you will need to assign a new mode that can work in conjunction with the unauthenticated mode (or other modes). Bottom-line, a new value in the Modes field is required during test session establishment. You will also need a good name for it e.g. UDP checksum mode.

Regards
Steve Baillargeon

From: [email-masked] [mailto:[email-masked]] On Behalf Of Tal Mizrahi
Sent: May-28-13 12:26 PM
To: [email-masked]
Subject: [ippm] New Draft: draft-mizrahi-owamp-twamp-checksum-trailer-00

Hi,

History:

Current version:

Thanks,
Tal.

---

From: Greg Mirsky <[email-masked]>
Date: Tue, 28 May 2013 16:41:23 -0700

Hi Tal,
yours is very interesting work.
Couple comments:

   - I think that requirement of at least 2 octets of padding might be not
   sufficient to work with section 4.2.1 of RFC 5357 that suggests that
   Session-Reflector MAY re-use packet padding for reflected packet. For
   Reflector to use Checksum Trailer mode packet padding in TWAMP-Test packet
   sent by Sender must be at least 29 octets in unauthenticated mode and 58 in
   authenticated and encrypted modes;
   - last paragraph in section 3.2.1 implicitly requires that if Checksum
   Trailer mode desired, packet padding must be used. I think that puts forth
   some requirements for OWAMP and TWAMP Control that would be useful to make
   explicit;
   - I'd consider how Checksum Trailer mode can be used with TWAMP test
   session negotiated with RFRC 6038;
   - I think that proposed mode has implication on TWAMP-Light operation.
   If TWAMP-Sender uses Checksum Trailer mode and sent test packet has
   sufficient number of octets so that Reflector will return at least two
   octets of padding, then Sender might interpret the last two octets as
   Checksum Trailer. I think that impact on TWAMP-Light needs to be discussed.

Regards,

Greg

On Tue, May 28, 2013 at 9:26 AM, Tal Mizrahi <[email-masked]> wrote:

> Hi,****
>
> ** **
>
> History:****
>
> **-          **
> http://tools.ietf.org/html/draft-mizrahi-tictoc-checksum-trailer-00
> Originally submitted to TICTOC in 2011, and discussed checksum trailers
> for both NTP and OWAMP/TWAMP.****
>
> **-          **There was some discussion in the mailing list:
> http://www.ietf.org/mail-archive/web/ntp/current/msg00492.html****
>
> **-          **Some discussion in IETF 81:
> http://tools.ietf.org/wg/tictoc/minutes?item=minutes81.html****
>
> ** **
>
> Current version:****
>
> **-          **Split into 2 drafts. There are some similarities, but
> still it is more appropriate to discuss it as two separate drafts:****
>
> http://tools.ietf.org/html/draft-mizrahi-owamp-twamp-checksum-trailer-00**
> **
>
> **-          **[NTP draft] Clarified the usage of the NTP extension field
> without authentication.
> ****
>
> ** **
>
> Comments will be appreciated.****
>
> ** **
>
> Thanks,****
>
> Tal.****
>
> ** **
>
> _______________________________________________
> ippm mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/ippm
>
>

---

From: Tal Mizrahi <[email-masked]>
Date: Wed, 29 May 2013 06:44:47 +0300

Hi Steve,

Thanks for the feedback.
I was hoping not to create a new mode, since the new <Checksum Trailer> field is piggybacked in the padding, and is thus transparent to the reflector (TWAMP) and receiver (OWAMP).

Thanks,
Tal.

From: Steve Baillargeon [mailto:[email-masked]]
Sent: Tuesday, May 28, 2013 11:02 PM
To: Tal Mizrahi; [email-masked]
Subject: RE: New Draft: draft-mizrahi-owamp-twamp-checksum-trailer-00

Hi Tal
Good work!

Regards
Steve Baillargeon

Hi,

History:

Current version:

Thanks,
Tal.

---

From: Tal Mizrahi <[email-masked]>
Date: Wed, 29 May 2013 08:50:37 +0300

Hi Greg,

Thanks for your comments.
>I think that requirement of at least 2 octets of padding might be not sufficient to work with section 4.2.1 of RFC 5357 that suggests that Session-Reflector MAY re-use packet padding for reflected packet. For Reflector to use Checksum Trailer mode packet padding in TWAMP-Test packet sent by Sender must be at least 29 octets in unauthenticated mode and 58 in authenticated and encrypted modes;
That's a good point, and I will add discussion about this in the next draft.
Note, however, that there are 2 possible scenarios:

(1)    Reflector supports Checksum Trailer - your comment is indeed relevant in this case.

(2)    Sender supports Checksum Trailer, but Reflector does not support Checksum Trailer - in this case the Checksum Trailer is only used in the sender-->reflector packet, and thus the 2 octets of padding suffice. The Checksum Trailer is not used in the reflector-->sender packet, there is no need for 29/58 octets of padding in the original packet.
Obviously, the sender does not necessarily know whether the reflector supports the Checksum Trailer or not, and thus it is probably good practice to append 29/58 octets.
>last paragraph in section 3.2.1 implicitly requires that if Checksum Trailer mode desired, packet padding must be used. I think that puts forth some requirements for OWAMP and TWAMP Control that would be useful to make explicit;
Right, as section 3.2 says: "The length of the Packet Padding field in test packets is announced during the session initiation through the "Padding Length" field in the Request-Session message [OWAMP], or in the Request-TW-Session [TWAMP]."
I will clarify this in 3.2.1 as well.

>I'd consider how Checksum Trailer mode can be used with TWAMP test session negotiated with RFRC 6038;
I will look into it and address it in the next draft.

>I think that proposed mode has implication on TWAMP-Light operation. If TWAMP-Sender uses Checksum Trailer mode and sent test packet has sufficient number of octets so that Reflector will return at least two octets of padding, then Sender might interpret the last two octets as Checksum Trailer. I think that impact on TWAMP-Light needs to be discussed.
It is important to note that when a sender receives a test packet it does not care whether the packet includes a Checksum Trailer or not. The reflector may or may not use a Checksum Trailer when reflecting the test packet; in both cases when the sender receives the test packet it simply treats the Checksum Trailer as part of the padding.

Thanks,
Tal.

From: Greg Mirsky [mailto:[email-masked]]
Sent: Wednesday, May 29, 2013 2:41 AM
To: Tal Mizrahi
Cc: [email-masked]
Subject: Re: [ippm] New Draft: draft-mizrahi-owamp-twamp-checksum-trailer-00

Hi Tal,

 *   I think that requirement of at least 2 octets of padding might be not sufficient to work with section 4.2.1 of RFC 5357 that suggests that Session-Reflector MAY re-use packet padding for reflected packet. For Reflector to use Checksum Trailer mode packet padding in TWAMP-Test packet sent by Sender must be at least 29 octets in unauthenticated mode and 58 in authenticated and encrypted modes;
 *   last paragraph in section 3.2.1 implicitly requires that if Checksum Trailer mode desired, packet padding must be used. I think that puts forth some requirements for OWAMP and TWAMP Control that would be useful to make explicit;
 *   I'd consider how Checksum Trailer mode can be used with TWAMP test session negotiated with RFRC 6038;
 *   I think that proposed mode has implication on TWAMP-Light operation. If TWAMP-Sender uses Checksum Trailer mode and sent test packet has sufficient number of octets so that Reflector will return at least two octets of padding, then Sender might interpret the last two octets as Checksum Trailer. I think that impact on TWAMP-Light needs to be discussed.

Regards,

Greg

On Tue, May 28, 2013 at 9:26 AM, Tal Mizrahi <[email-masked]<mailto:[email-masked]>> wrote:
Hi,

History:

Current version:

Thanks,
Tal.

_______________________________________________
ippm mailing list
[email-masked]<mailto:[email-masked]>
https://www.ietf.org/mailman/listinfo/ippm

---

From: Steve Baillargeon <[email-masked]>
Date: Wed, 29 May 2013 12:56:17 +0000

Hi Tal

Based on your draft: UDP over IPv6, as defined in [IPv6], does not allow a zero checksum, and requires the UDP checksum field to contain a
correct checksum of the UDP payload.
How will bypass this requirement without "configuring" (via signaling or out-of-band configuration) the responder to ignore the UDP checksum?

How much saving (CPU cycles) do you expect between 1)  update the timestamp field, and then update the Checksum Trailer and 2) update the timestamp and then update the UDP checksum residing at the UDP header?

-Steve

From: Tal Mizrahi [mailto:[email-masked]]
Sent: May-28-13 11:45 PM
To: Steve Baillargeon; [email-masked]
Subject: RE: New Draft: draft-mizrahi-owamp-twamp-checksum-trailer-00

Hi Steve,

Thanks for the feedback.

Thanks,
Tal.

From: Steve Baillargeon [mailto:[email-masked]]
Sent: Tuesday, May 28, 2013 11:02 PM
To: Tal Mizrahi; [email-masked]<mailto:[email-masked]>
Subject: RE: New Draft: draft-mizrahi-owamp-twamp-checksum-trailer-00

Hi Tal
Good work!

Regards
Steve Baillargeon

From: [email-masked]<mailto:[email-masked]> [mailto:[email-masked]] On Behalf Of Tal Mizrahi
Sent: May-28-13 12:26 PM
To: [email-masked]<mailto:[email-masked]>
Subject: [ippm] New Draft: draft-mizrahi-owamp-twamp-checksum-trailer-00

Hi,

History:

Current version:

Thanks,
Tal.

---

From: Tal Mizrahi <[email-masked]>
Date: Wed, 29 May 2013 17:17:22 +0300

Steve,

> How will bypass this requirement without "configuring" (via signaling or out-of-band configuration) the responder to ignore the UDP checksum?

The receiver does not ignore the checksum. The sender changes the value of the Checksum Trailer to a value that makes the UDP Checksum field correct. The receiver simply treats the Checksum Trailer as part of the padding (i.e., part of the UDP payload).

>How much saving (CPU cycles) do you expect between 1)  update the timestamp field, and then update the Checksum Trailer and 2) update the timestamp and then update the UDP checksum residing at the U…

Well, since I work for a silicon vendor, I was thinking more about silicon implementations, where you update the timestamp in the chip.
In such implementations, you often process the data in a serial manner, a few bytes at a time.
So as you go over the packet: you first process the UDP header (including the checksum), and then process the payload (including the timestamp). At this point you know how you want to update the UDP checksum, but it is already too late since the UDP header may have already been transmitted. It's still not too late to update the Checksum Trailer at the end of the packet, so it is updated to a value that keeps the existing UDP checksum correct.

Regards,
Tal.

From: Steve Baillargeon [mailto:[email-masked]]
Sent: Wednesday, May 29, 2013 3:56 PM
To: Tal Mizrahi; [email-masked]
Subject: RE: New Draft: draft-mizrahi-owamp-twamp-checksum-trailer-00

Hi Tal

-Steve

Hi Steve,

Thanks for the feedback.

Thanks,
Tal.

Hi Tal
Good work!

Regards
Steve Baillargeon

Hi,

History:

Current version:

Thanks,
Tal.

---

From: Steve Baillargeon <[email-masked]>
Date: Wed, 29 May 2013 14:37:36 +0000

Hi Tal
I see your point now.
I agree that a local configuration to use or not to use a Checksum Trailer for outgoing test packets should be sufficient (at least in unauthenticated mode).
I agree that a new TWAMP mode is not needed.

-Steve

Sent: May-29-13 10:17 AM

Steve,

Regards,
Tal.

Hi Tal

-Steve

From: Tal Mizrahi [mailto:[email-masked]]
Sent: May-28-13 11:45 PM
To: Steve Baillargeon; [email-masked]<mailto:[email-masked]>
Subject: RE: New Draft: draft-mizrahi-owamp-twamp-checksum-trailer-00

Hi Steve,

Thanks for the feedback.

Thanks,
Tal.

Hi Tal
Good work!

Regards
Steve Baillargeon

Hi,

History:

Current version:

Thanks,
Tal.